Allow uploading of 3D files to Wikimedia Commons
Open, Needs TriagePublic

Subscribers
Tokens
"Love" token, awarded by Jopparn."Like" token, awarded by Elitre."Love" token, awarded by Lucasstar1."Love" token, awarded by Kozuch."Mountain of Wealth" token, awarded by Sylvain_WMFr."Love" token, awarded by Qupro."Love" token, awarded by Liuxinyu970226."Like" token, awarded by 1Veertje."Like" token, awarded by ChristianKl."Love" token, awarded by Mrjohncummings."Mountain of Wealth" token, awarded by Pine."Like" token, awarded by Ebraminio."Love" token, awarded by Moushira."Mountain of Wealth" token, awarded by Micru."Love" token, awarded by waldyrious."Like" token, awarded by Ricordisamoa.
Assigned To
None
Authored By
bzimport, Mar 31 2005

Description

Please allow registered users to upload .blend files to the commons. I would
like to start a repository of Blender 3D resources including .blend files for
public use and for use with certain Blender 3D wiki projects, such as
http://en.wikibooks.org/wiki/Blender_3D:_Noob_to_Pro .

Perhaps create a new type, instead of just Images and Sound, add Source Files,
or maybe Sources?

This card tracks a proposal from the 2015 Community Wishlist Survey: https://meta.wikimedia.org/wiki/2015_Community_Wishlist_Survey

This proposal received 56 support votes, and was ranked #11 out of 107 proposals.

https://meta.wikimedia.org/wiki/2015_Community_Wishlist_Survey/Commons#3D_models_on_Wikimedia_Commons

This proposals received 33 support votes, and was ranked #33 out of 256 proposals in the Community-Wishlist-Survey-2016. View full proposal and discussion here.

Details

Reference
bz1790

Related Objects

StatusAssignedTask
OpenNone
OpenNone
DeclinedNone
OpenNone
OpenNone
ResolvedMarkTraceur
DuplicateSnhkicker
ResolvedMarkTraceur
ResolvedNone
ResolvedNone
ResolvedGilles
ResolvedGilles
ResolvedGilles
ResolvedGilles
ResolvedReedy
ResolvedRicordisamoa
ResolvedMarkTraceur
ResolvedJdforrester-WMF
ResolvedJdforrester-WMF
ResolvedMarkTraceur
ResolvedMarkTraceur
ResolvedGilles
OpenNone
OpenCKoerner_WMF
Resolveddr0ptp4kt
Resolvedmatthiasmullie
OpenCKoerner_WMF
ResolvedCKoerner_WMF
Resolvedmatthiasmullie
There are a very large number of changes, so older changes are hidden. Show Older Changes

Hello, is there an update on progress for this task?

Hello, is there an update on progress for this task?

No movement yet. Status is this task -> T54655 -> T131723 (just added ->) T132063: Security review of 3d2png as the current main blocker.

The security review is scheduled for this week according to the task @Jdforrester-WMF just linked to.

Does anyone know a rough date when 3D models (.stl and/or .amf files) will be supported on Wikimedia Commons and usable other Wikimedia projects?

This is a spare time project for all involved at the moment, we can't commit to a specific timeline. Right now I'm slowly working on addressing the concerns of the server-side that were brought up in security review: T132063. I think I might drop support for AMF, which is XML-based, because XML is a source of too many security attack vectors (security review revealed a simple method which would put the converting process in an infinite loop, no less, because of a vulnerability in an upstream library). STL is the de facto standard anyway, I haven't seen any real sign that AMF has traction. Until AMF is popular, I don't think it's worth the risk of messing with another risky XML format.

Mrjohncummings added a comment.EditedAug 17 2016, 10:05 AM

@Gilles thanks for the update.

The reason why .amf is included is that .stl isn't an open format so goes against the policy of Commons only accepting free formats.

https://commons.wikimedia.org/wiki/Commons:File_types

It seems unlikely .stl will be accepted on Commons even if it is technically possible. I have asked on the talk page about it here about if it will run out of protection soon since it was created in 1988.

https://commons.wikimedia.org/wiki/Commons_talk:File_types#Supporting_.stl

.amf is the only widely used open file format that is available (its becoming more popular in 3D printing as it can include multiple materials). WMUK did some scoping of supporting 3D files and .amf was the only choice available for free 3D filetypes.

I don't see a way around supporting .amf, any ideas?

Thanks very much

John

That's unfortunate. AMF made a terrible decision using XML for a format that simple. The fact that security review found an exploit in a library I used as serious as creating an infinite loop on the server side with a 2-character XML file shows how dangerous anything XML-based can be. SVG support has been a thorn on our side for many years because of that very problem (still worth having, but a pain to maintain). And unfortunately the work done over the years to secure our SVG support is of little use for AMF, as the library stack is completely different (different language in this case).

Since AMF seems to have very little traction yet, maybe we could start a discussion with the people who designed the format about moving away from XML. Even using JSON instead would be enough to get rid of all the security issues, while retaining the upside of having a base format that many libraries support. I'll try to reach out to them.

We could also explore the route of identifying the copyright holders of the STL format, if there are any, and asking them if they would consider making the format open. That might be more effective, considering that STL is already the de facto standard in terms of use. I'll file a task and ask the WMF legal team if that's something they could help with.

Sumit added a comment.Sep 13 2016, 7:09 AM

I'm not aware of the technical developments but could this task use help from an Outreachy intern( Dec 6 to March 6 )? Please note that applications are open until Oct - 17.

Let us know if possible at the earliest.

Qupro added a subscriber: Qupro.Oct 24 2016, 10:16 AM

Hi, It could be good join forces with FreeCAD Community:

  • They use .STL and many others 3D file formats but its main is FCStd, which is exportable to others.

I guess is an open format but support this file in Common's will build bridges between open source projects anyway.

greetings

Qupro awarded a token.Jan 5 2017, 12:08 PM
Torana added a subscriber: Torana.Jan 9 2017, 9:44 PM
MarkTraceur moved this task from Desired epics to Doing on the Multimedia board.Jan 27 2017, 10:50 PM
MarkTraceur added a subscriber: MarkTraceur.

Via the weekly community digest I discovered today the existence of MediaWiki-extensions-StlHandler / R1904. Don’t think it had been mentioned on this thread before (besides the mention in T134005)

Any updates on this task? Would this be suitable for GSoC or Outreachy? We are currently recruiting projects and mentors for May-Aug 2017.

Any updates on this task? Would this be suitable for GSoC or Outreachy? We are currently recruiting projects and mentors for May-Aug 2017.

T132058: 3d extension supporting STL (3d printing files) is mostly complete, and will mean the main request here is Resolved, so no, I don't think it'd be a good fit.

ClemFlip removed a subscriber: ClemFlip.Feb 17 2017, 9:16 AM

Any updates on this task? Would this be suitable for GSoC or Outreachy? We are currently recruiting projects and mentors for May-Aug 2017.

T132058: 3d extension supporting STL (3d printing files) is mostly complete, and will mean the main request here is Resolved, so no, I don't think it'd be a good fit.

Perhaps extending the supported formats to OBJ could be a possible task for GSoC or Outreachy, then? I listed some advantages of this format in T145502.

Perhaps extending the supported formats to OBJ could be a possible task for GSoC or Outreachy, then? I listed some advantages of this format in T145502.

Definitely (but not as this task), or for PLY files.

Note that X3D or other file formats which embed textures/etc. would be blocked by T131723: Provide a mechanism to sanitise user-generated non-STL 3D files to meet security requirements, which is probably worthy of a PhD.

Aeglius removed a subscriber: Aeglius.Mar 7 2017, 3:19 PM
Lucasstar1 added a subscriber: Lucasstar1.
dr0ptp4kt raised the priority of this task from Low to Normal.May 8 2017, 3:29 PM

@dr0ptp4kt Setting priority is in general a very sensitive action, and should always reflect the actual reality, not just cause it. So what's the reason that you believe that someone is working on this?

@Liuxinyu970226: See the quarterly check-in slides of WMF's Editing Team and the subtasks recently added. Priority does reflect the reality of planning here.

@Liuxinyu970226, thank you for your message. The Multimedia team (which only recently moved into Reading) is carrying over its work from Q3 FY 2016-2017 (January - March 2017) on 3D to Q4 FY 2016-2017 (April - June 2017). Refer to https://www.mediawiki.org/wiki/Wikimedia_Engineering/2016-17_Q4_Goals#Reading for further information.

Do note the initial supported file format for the feature is .stl. I can't fairly comment on support for additional file formats in the future, but did just want to draw attention to the file format for the initial planned release, as the description and comments on this task discuss multiple file formats.

Tgr added a comment.May 10 2017, 3:54 PM

In general, priority changes made by the Director of Engineering at Reading to a task owned by one of the Reading department teams can probably be assumed to be authoritative :)

To be fair, I do make mistakes sometimes when updating tasks! That said, in this case, yes, we're good on the Normal priority - we're excited to be working on 3D support!

Jopparn added a subscriber: Jopparn.
Daylen added a subscriber: Daylen.Jul 23 2017, 1:49 AM
Sj added a comment.Aug 17 2017, 8:50 PM

A most important task! thanks for working on this.

Since thousands of communities manage to allow uploading of lots of file formats that haven't passed our security review, perhaps there are creative technical solutions that allow for wiki communities to wait until problems arise before solving all of them. For instance:

  • Having a separate server handly files with not-fully-sanitized extensions
  • Displaying not-fully-sanitized files with a different background color or other indicator that it may deserve checking for safety
  • Increasing requirements for the upload workflow, before uploaded files are available to readers for viewing/download (greater reputation requirement; requiring a file-reviewer to touch/approve the upload)
mxn added a subscriber: mxn.Sep 2 2017, 1:40 AM
MarkTraceur moved this task from Doing to Desired epics on the Multimedia board.Sep 7 2017, 4:15 PM
MarkTraceur raised the priority of this task from Normal to Needs Triage.
Zaenon added a subscriber: Zaenon.Sep 10 2017, 8:07 AM
Koavf added a subscriber: Koavf.Sep 14 2017, 10:57 PM
Koavf added a comment.Sep 16 2017, 3:25 AM
  • Displaying not-fully-sanitized files with a different background color or other indicator that it may deserve checking for safety

This already happens on Commons with PDFs--there is an automatic warning sign.

  • Increasing requirements for the upload workflow, before uploaded files are available to readers for viewing/download (greater reputation requirement; requiring a file-reviewer to touch/approve the upload)

Between advanced user rights and an edit filter tag, I think this would solve 99% of the problems.

Quoth removed a subscriber: Quoth.Oct 18 2017, 8:44 PM
Ramsey-WMF moved this task from Desired epics to Next up on the Multimedia board.Dec 4 2017, 7:04 PM
Theklan added a subscriber: Theklan.Thu, Feb 1, 6:21 PM

Hello! I don't know if this is exactly the same thing, but we are thinking on buying this: http://orangemonkie.com/product/foldio360-studio-set/ so we can do some photos of students' made architecture models for our education program. We could do a video of the object rotating, but it would be greater to have something that can be moved by hand.

Would it work sometime in the future? Or is a nonsense to even try to do it now?

Thanks!

TheDJ added a comment.Fri, Feb 2, 10:39 AM

@Theklan it seems that that technology doesn't create true 3D objects.. Just a series of images Example: https://dz6wgdw9omh7h.cloudfront.net/foldio360/sample-shop/images/iron.jpg

The particular feature discussed in this ticket deals with 3d objects such as used for 3D printers. https://en.wikipedia.org/wiki/STL_(file_format)

While we have several tickets related to 3D panoramas and related photography based techniques, none of those are currently planned to be worked on any time soon, and I'm not sure this technique is a standardised one that would fit into those tickets either.

Thanks @TheDJ... so maybe a video or a gif would work better!